#pragma once

#include "define.h"
#include <cassert>

#define assertm(exp, msg) assert(((void)msg, exp))



class SPI
{
  SPI_TypeDef *reg;
  
public:
  explicit SPI( SPI_TypeDef *_reg ) : reg( _reg ) {}
  
  void initSPI();
  
  void sendByte( const uint8_t byte );
  void sendData( const void *arr, uint8_t length );
  
  uint8_t readByte();
  void readData( void *data, uint8_t length );
};