#pragma once

#include "define.h"

class Delay
{
  TIM_TypeDef *reg;
  
public:
  explicit Delay( TIM_TypeDef *_reg ) 
  { 
    reg = _reg; 
    reg->CR1 |= TIM_CR1_CEN;
  }
  
  void msDelay( uint16_t ms )
  {
    reg->ARR = 1000 * ms;
    reg->CNT = 0;
    while ( reg->CNT < ms );
    reg->ARR = 0;
  }
  
  void usDelay ( uint16_t us )
  {  
    reg->ARR = us;
    reg->CNT = 0;
    while ( reg->CNT < us );
    reg->ARR = 0;
  }
};