#pragma once 

#include "define.h"

class Pin
{
  GPIO_TypeDef *gpio;
  const uint32_t pinNum;
  
public:
  Pin( GPIO_TypeDef *_gpio, const uint32_t _pinNum )
    : gpio( _gpio ), pinNum( _pinNum ) {}
    
  void Set()    { gpio->ODR |= (1 << pinNum); }
  void Clear()  { gpio->ODR &= ~(1 << pinNum); }
  void Toggle() { gpio->ODR ^= (1 << pinNum); }
};
