#include "define.h"
#include "SPI.h"
#include "DisplayDriver.h"
#include "Display.h"
#include "Color.h"
#include "adc.h"
#include "dma.h"
#include "IVariable.h"
#include "driverEnc28.h"

//Adc adc1( ADC1, new Dma< uint16_t, 3 >( DMA2_Stream0, (uint32_t)&(ADC1->DR) ) );
DmaAdc dmaADC( DMA2_Stream0, (uint32_t)&(ADC1->DR) );
Adc adc1( ADC1, &dmaADC );
uint16_t rawData;
uint16_t buff[3];

SPI spi1( SPI1 );
Pin res( GPIOA, 2 );
Pin cs( GPIOA, 4 );
ENC28J60 enc28( &spi1, &res, &cs );
//ST7735 st7735( &spi1, Pin(GPIOB, 5), Pin( GPIOB, 7 ), Pin( GPIOB, 3 ), 128, 160 );

float temperature;
float voltage;
float tempResistor;

uint8_t mac[6] = { 0x55, 0xEA, 0x4C, 0x5B, 0x40, 0x42 };
uint8_t txPackage[10] = { 0x00, 0x10, 0x20, 0x30, 0x40, 0x50, 0x60, 0x70, 0x80, 0x90 };
uint32_t tmp;
/*----------------------------------------------------------------------------*/
extern "C" void MainTask()
{
    spi1.initSPI();
//    st7735.Init();
      
    //--------------------------ENC28J60--------------------------------------//
    enc28.setTxBuffer( txPackage, sizeof( txPackage ) );
    enc28.init( mac );
    //------------------------ADC and DMA-------------------------------------//
//    adc1.StartDMA( true );
//    adc1.StartADC( true );
//    adc1.Conv( true );
//    
//    Temperature Temp(&adc1);
//    IVariable *pv = &Temp;
////    RefVoltage Voltage(&adc1);
////    Sensor TempResistor(&adc1);
    //------------------------------------------------------------------------//
    
    while( 1 )
    {       
//      enc28.init( mac );
//      HAL_Delay( 200 );
//      CLEAR_BIT( GPIOD->ODR, GPIO_ODR_OD15 );
      
      enc28.sendPackage( 10 );      
      tmp++;
    }
}






