#pragma once

#include "define.h"
#include "dma.h"

class Adc 
{
  ADC_TypeDef *adc;
    
public:
  Adc( ADC_TypeDef *_adc );
  IDma *dma;
  
  /*---------------------------DMA---------------------------*/
  Adc( ADC_TypeDef *_adc, IDma *_dma ) : adc(_adc), dma(_dma){}  
  bool StartDMA( bool swtch );
  /*---------------------------------------------------------*/
  bool StartADC( bool swtch ); 
  bool Conv( bool swtch );
  uint16_t Resalt();
  
  void IRQ_Handler();
  
private:
  bool convDirect();
  bool convInterrupt();
  bool convDMA();
};