#include "adc.h"


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
Adc::Adc( ADC_TypeDef *_adc )
{
  adc = _adc;
}
/*----------------------------------------------------------------------------*/
bool Adc::StartDMA( bool swtch )
{
  if ( swtch ) 
  {
    SET_BIT( adc->CR2, ADC_CR2_DMA );
    dma->initDMA();
  }
  else         
  {
    SET_BIT( adc->CR2, ~ADC_CR2_DMA );
  }
  
  bool stateDMA = ( adc->CR2 & ADC_CR2_DMA );
  return stateDMA;
}
/*----------------------------------------------------------------------------*/
bool Adc::StartADC( bool swtch )
{
  if ( swtch ) SET_BIT( adc->CR2, ADC_CR2_ADON );
  else         SET_BIT( adc->CR2, ~ADC_CR2_ADON );
  
  bool stateStart = ( adc->CR2 & ADC_CR2_ADON );
  return stateStart;
}
/*----------------------------------------------------------------------------*/
bool Adc::Conv( bool swtch )
{
  if ( swtch )
  {
    SET_BIT( adc->CR2, ADC_CR2_SWSTART );
    while ( READ_BIT( adc->SR, ADC_SR_STRT ) );
  }
  else
  {
    SET_BIT( adc->CR2, ~ADC_CR2_SWSTART );
  }
  
  bool stateConv = ( adc->CR1 & ADC_CR2_SWSTART );
  return stateConv;
}
/*----------------------------------------------------------------------------*/
uint16_t Adc::Resalt()
{
  while ( READ_BIT( adc->SR, ADC_SR_EOC ) );
  return adc->DR;
}
/*----------------------------------------------------------------------------*/
void Adc::IRQ_Handler()
{
  
}
/*----------------------------------------------------------------------------*/
bool Adc::convDirect()
{
  
}
/*----------------------------------------------------------------------------*/
bool Adc::convInterrupt()
{

}
/*----------------------------------------------------------------------------*/
bool Adc::convDMA()
{

}









