#include "iVariable.h"

float Temperature::calculate()
{
  float value;
  value = ( (float)((uint16_t)pAdc->dma->value(0) - voltage) / average ) + 25;
  return value;
}
/*----------------------------------------------------------------------------*/
float RefVoltage::calculate()
{
  float value;
  value = ( (float)((uint16_t)pAdc->dma->value(1)) / 1000 );  
  return value;
}
/*----------------------------------------------------------------------------*/
float Sensor::calculate()
{
  float value;
  value = (float)((uint16_t)pAdc->dma->value(2) * 3.3) / 4096;
  return value;
}
/*----------------------------------------------------------------------------*/