#include "dma.h"

/*----------------------------------------------------------------------------*/
void DmaAdc::initDMA()
{
  stream->CR &= ~DMA_SxCR_EN;
  stream->PAR |= addrPeriph;
  stream->M0AR |= (uint32_t)&pBuff[0];
  stream->NDTR |= ARR_ADC;
  stream->CR |= DMA_SxCR_EN;
}
/*----------------------------------------------------------------------------*/
uint32_t DmaAdc::value( uint16_t idx )
{
  return pBuff.at( idx );
}
/*----------------------------------------------------------------------------*/
